# This function always returns a single digit integer as the check digit.
# The input and multiplier are strings.
# The modulus is an integer (usually 10 or 11).
# Set sum_digits to true if you want a sum of the product digits.
# Set rtl to true if the multiplier string should be created from right to left.
def check_digit(input, multiplier, modulus, sum_digits = false, rtl = false)
	# Correct input arguments.
	input = input.to_s
	multiplier = multiplier.to_s
	modulus = modulus.to_i
	sum_digits = false unless sum_digits.kind_of? TrueClass
	rtl = false unless rtl.kind_of? TrueClass
	
	# Create multiplier string.
	extra = input.length % multiplier.length
	if rtl
		multiplier.reverse! 
		multiplier = multiplier[-extra, extra] + (multiplier * (input.length / multiplier.length))
	else
		multiplier = (multiplier * (input.length / multiplier.length)) + multiplier[0, extra]
	end
	
	# Generate the sum.
	sum = 0
	0.upto(input.length-1) { |i|
		step = input[i, 1].to_i * multiplier[i, 1].to_i
		# Do they want sum of the products, or sum of the product digits?
		if (sum_digits)
			sum += step % 10 + step / 10
		else
			sum += step
		end
	}

	# Value to return as a single digit integer.
	((modulus - (sum % modulus)) % modulus) % 10
end
